﻿/*
OuDiaSecond Copyright (C) 2017-2019 diagram_mania

このプログラムは、take-okm氏が作成したOuDiaを改造したソフトウェアです。
このプログラム利用については、take-okm氏記載の下記文書に準拠します。
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(訳: 

	OuDia - 列車時刻表をもとに、ダイヤグラムを描画するWin32アプリケーシ
ョン。

Copyright (C) 2006-2017 take-okm 

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財
団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、それ以降のバージョ
ンのうちどれか)が定める条件の下で再頒布または改変 することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。
商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在
しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部 受け取っ
ているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> を
ご覧ください。

)

  加えて、特別な例外として、take-okm はこのプログラムのコードを 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  あるいは "MFC Version 9.0" と同じライセンスが適用された
  "MFC Version 9.0" の改変されたバージョン)とリンクし、
  リンクされた両者を含む結合著作物を頒布する許可を与えます。
  あなたは "MFC" 以外で使われているすべて
  のコードに関しては全面的にGNU一般公衆利用許諾契約書に従わなければ
  なりません。あなたがこのファイルを改変したならば、あなたはこの例外
  をあなたのバージョンのファイルに引き続き設けることもできますが、そ
  うする義務はありません。もし例外を設けたくなければ、この例外条項を
  あなたのバージョンからは削除してください。)
*/
// ****************************************************************
// $Id: CconvJikokuhyouCustomizeCsv.cpp 
// ****************************************************************
#include "stdafx.h"
#include "CconvJikokuhyouCustomizeCsv.h"
#include "str\strprintf.h"
//#include "..\ViewJikokuhyou\JikokuhyouColSpec\CdYColSpecCont.h"
#include "Str/stringSplit.h"
#include "..\entDed\CentDedBeforeOperation.h"
#include "..\entDed\CentDedAfterOperation.h"
#include <algorithm>

namespace ConvJikokuhyouCsv{

using namespace std ;
using namespace OuLib ;
using namespace OuLib::Str ;

//using ViewJikokuhyou::JikokuhyouColSpec::CdYColSpecCont;
//using ViewJikokuhyou::JikokuhyouColSpec::CdYColSpec;

/**
	FileTypeの 名前
*/
const TCHAR* const nameFileType = _T("FileType") ;

/**
	FileType の値
*/
const TCHAR* const nameFileTypeValue = _T("OuDiaSecond.JikokuhyouCsv.3") ;

const int CSVROWINDEX_Ressyabangou = 4 ;
const int CSVROWINDEX_Ressyasyubetsu = 5 ;
const int CSVROWINDEX_Ressyamei = 6 ;
const int CSVROWINDEX_Gousuu = 7 ;
const int CSVROWINDEX_Gou = 8 ;
const int CSVROWINDEX_Ekijikoku0 = 9 ;
const int CSVCOLUMNINDEX_Ressya0 = 2 ;

/** 時刻の書式を保持します。 */
const CdDedJikoku::CConv	g_CdDedJikokuConv(
	true ,		//	NoColon 
	// 時が 00 から 09 の場合、10の位の "0" を削除します。
	CdDedJikoku::CConv::EHour_ZeroToNone ,	
	CdDedJikoku::CConv::ESecond_NoSecond 	// 秒を常に出力しません。 
	) ;

const CdDedJikoku::CConv	g_CdDedJikokuConvSecond(
	true,		//	NoColon 
				// 時が 00 から 09 の場合、10の位の "0" を削除します。
	CdDedJikoku::CConv::EHour_ZeroToNone,
	CdDedJikoku::CConv::ESecond_Output 	
);
const CdDedJikoku::CConv	g_CdDedJikokuConvColon(
	false,		//	Colon 
				// 時が 00 から 09 の場合、10の位の "0" を削除します。
	CdDedJikoku::CConv::EHour_ZeroToNone,
	CdDedJikoku::CConv::ESecond_NoSecond 	// 秒を常に出力しません。 
);

const CdDedJikoku::CConv	g_CdDedJikokuConvSecondColon(
	false,		//	Colon 
				// 時が 00 から 09 の場合、10の位の "0" を削除します。
	CdDedJikoku::CConv::EHour_ZeroToNone,
	CdDedJikoku::CConv::ESecond_Output
);

	// --------------------------------
	//@name	駅時刻セルの文字列の解釈
	// --------------------------------
tstring CconvJikokuhyouCustomizeCsv::encode_Ekijikoku( 
		CentDedEkiJikoku::EEkiatsukai eEkiatsukai , 
		const CdDedJikoku& aCdDedJikoku ,
		const bool bDisplaySecondEkiJikoku,
		const bool bDisplayColonEkiJikoku)
{
	tstring strValue = _T("");
	switch( eEkiatsukai )
	{
	case CentDedEkiJikoku::Ekiatsukai_Teisya:
		{
			if (bDisplaySecondEkiJikoku) {
				if (bDisplayColonEkiJikoku)
				{
					strValue = g_CdDedJikokuConvSecondColon.encode(aCdDedJikoku);
				}
				else
				{
					strValue = g_CdDedJikokuConvSecond.encode(aCdDedJikoku);
				}
			}
			else 
			{
				if (bDisplayColonEkiJikoku)
				{
					strValue = g_CdDedJikokuConvColon.encode(aCdDedJikoku);
				}
				else
				{
					strValue = g_CdDedJikokuConv.encode(aCdDedJikoku);
				}
			}
		}
		break ;
	case CentDedEkiJikoku::Ekiatsukai_Tsuuka:
		{
			if (bDisplaySecondEkiJikoku) {
				strValue = _T("");
				if (bDisplayColonEkiJikoku)
				{
					strValue += g_CdDedJikokuConvSecondColon.encode(aCdDedJikoku);
				}
				else
				{
					strValue += g_CdDedJikokuConvSecond.encode(aCdDedJikoku);
				}
				strValue += _T("?");
			}
			else
			{
				strValue = _T("");
				if (bDisplayColonEkiJikoku)
				{
					strValue += g_CdDedJikokuConvColon.encode(aCdDedJikoku);

				}
				else
				{
					strValue += g_CdDedJikokuConv.encode(aCdDedJikoku);
				}
				strValue += _T("?");
			}
		}
		break ;
	}

	return strValue ;
}

// --------------------------------
	//@name encode() の下請関数	
	// --------------------------------

int CconvJikokuhyouCustomizeCsv::encode_AddRessya( 
		const Mu<const CentDedRessyasyubetsu*>* pCentDedRessyasyubetsuContGet ,
		const Mu<const CentDedRessya*>* pCentDedRessyaCont,
		const vector<int>& contCustomizeRessyaIndex, 
		CdCsvDocument* pCdCsvDocument ,
		const CentDedEkiCont* pCentDedEkiCont,
		const Mu<CentDedEkiCont::CdDedEki>* pCdDedEkiCont,
		const bool bDisplayTsuukaEkiJikoku,
		const bool bDisplaySecondEkiJikoku,
		const bool bDisplayColonEkiJikoku,
		const bool bDisplayShihatsuShuchakuEkimei,
		const bool bDisplayParentSyubetsu,
		const bool bDisplayRessyamei,
		const int iEnableOperation,
		const bool bDisplayOuterTerminalShihatsu,
		const bool bDisplayOuterTerminalShuchaku)
{
	int iRv = 0 ;

	int iRessyaIndex = 0;
	const CentDedRessya* pCentDedRessya = pCentDedRessyaCont->get(contCustomizeRessyaIndex[iRessyaIndex]);
	if ( iRv >= 0 )
	{
		if ( pCentDedRessya->isNull() ||
			pCentDedRessya->getValidSihatsuEki() == -1 ||
			pCentDedRessya->getValidSyuuchakuEki() == -1)
		{
			encode_AddRessyaNull(
				pCdCsvDocument,
				bDisplayShihatsuShuchakuEkimei,
				bDisplayRessyamei,
				iEnableOperation,
				bDisplayOuterTerminalShihatsu,
				bDisplayOuterTerminalShuchaku) ;
			return iRv;
		}
	}
	// --------------------------------
	const CentDedRessyasyubetsu* pCentDedRessyasyubetsu = NULL ;
	if ( iRv >= 0 )
	{
		pCentDedRessyasyubetsu 	= pCentDedRessyasyubetsuContGet
			->get( pCentDedRessya->getRessyasyubetsuIndex() ) ;
		if (bDisplayParentSyubetsu && pCentDedRessyasyubetsu->getParentSyubetsuIndex() >= 0)
		{
			pCentDedRessyasyubetsu = pCentDedRessyasyubetsuContGet
				->get(pCentDedRessyasyubetsu->getParentSyubetsuIndex());
		}
	}
	//pCentDedRessysyubetsu = 列車種別オブジェクト

	int iRowIndex = CSVROWINDEX_Ressyabangou;
	//＜2.5＞5行目 <列車番号>
	if ( iRv >= 0 )
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
		aRow.getCellCont()->insert( CdCsvCell( pCentDedRessya->getRessyabangou() ) ) ;
		pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
		iRowIndex++;
	}

	//＜2.6＞ <運用番号>
	if (iRv >= 0 && iEnableOperation > 1)
	{
		tstring strOperationNumber =
			joinc('+', pCentDedRessya->getOperationNumber(pCentDedRessya->getValidSihatsuEki()), true);
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell(strOperationNumber));
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
	}

	//＜2.7＞ <列車種別>
	if (iRv >= 0)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell(pCentDedRessyasyubetsu->getRyakusyou()));
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
	}

	//＜2.8＞<列車名>
	if ( iRv >= 0 && bDisplayRessyamei)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
		aRow.getCellCont()->insert( CdCsvCell( pCentDedRessya->getRessyamei() ) ) ;
		pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
		iRowIndex++;
	}

	//＜2.9＞<号数>
	if ( iRv >= 0 && bDisplayRessyamei)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
		aRow.getCellCont()->insert( CdCsvCell( pCentDedRessya->getGousuu() ) ) ;
		pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
		iRowIndex++;
	}
	//＜2.10＞<号表示>
	if ( iRv >= 0 && bDisplayRessyamei)
	{
		tstring	strValue ;
		if ( !pCentDedRessya->getGousuu().empty() )
		{
			strValue = m_nameGou ;
		}
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
		aRow.getCellCont()->insert( CdCsvCell( strValue ) ) ;
		pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
		iRowIndex++;
	}

	//＜2.11＞ <始発駅名>
	if (iRv >= 0&& bDisplayShihatsuShuchakuEkimei)
	{
		tstring strText;
		if (pCentDedRessya->getValidSihatsuEki() != -1)
		{
			if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Outer)
			{
				strText = pCdDedEkiCont->get(pCentDedRessya->getValidSihatsuEki()).getOuterTerminalJikokuRyaku(
					pCentDedRessya->getFirstOperation().getOuterShihatsuekiIndex(), true);
			}
			else
			{
				strText = pCdDedEkiCont->get(pCentDedRessya->getValidSihatsuEki()).getEkimeiJikokuhyouRyaku(true);
			}
		}
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell(strText));
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
	}
	
	//＜2.13＞ <終着駅名>
	if (iRv >= 0&& bDisplayShihatsuShuchakuEkimei)
	{
		tstring strText;
		if (pCentDedRessya->getValidSyuuchakuEki() != -1)
		{
			if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Outer)
			{
				strText = pCdDedEkiCont->get(pCentDedRessya->getValidSyuuchakuEki()).getOuterTerminalJikokuRyaku(
					pCentDedRessya->getLastOperation().getOuterShuchakuekiIndex(), true);
			}
			else
			{
				strText = pCdDedEkiCont->get(pCentDedRessya->getValidSyuuchakuEki()).getEkimeiJikokuhyouRyaku(true);
			}
		}
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell(strText));
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
	}
	
	//＜2.15＞ <路線外始発駅>
	if (iRv >= 0 && bDisplayOuterTerminalShihatsu)
	{
		tstring strText1;
		tstring strText2;

		const CentDedBeforeOperation aFirstOperation = pCentDedRessya->getFirstOperation();
		if (aFirstOperation.getBOperation() == CentDedBeforeOperation::BOperation_Outer)
		{
			CentDedEkiCont::CdDedEki aCdDedEki = pCdDedEkiCont->get(pCentDedRessya->getValidSihatsuEki());
			strText1 = aCdDedEki.getOuterTerminalJikokuRyaku(aFirstOperation.getOuterShihatsuekiIndex(), true);

			if (!(aFirstOperation.getOuterShihatsuJikoku().isNull()))
			{
				CdDedJikoku aCdDedJikoku
					= aFirstOperation.getOuterShihatsuJikoku();
				strText2 = encode_Ekijikoku(
					CentDedEkiJikoku::Ekiatsukai_Teisya,
					aCdDedJikoku,
					bDisplaySecondEkiJikoku,
					bDisplayColonEkiJikoku);
			}
		}

		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell(strText1));
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
		CdCsvRow	aRow2 = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow2.getCellCont()->insert(CdCsvCell(strText2));
		pCdCsvDocument->getRowCont()->set(aRow2, iRowIndex);
		iRowIndex++;
	}


	//＜2.10＞10行目～ 駅時刻
	
	if ( iRv >= 0 )
	{
		int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
		int iSyubetsuChangeEkiOrder = -1;
		int iConnectEkiOrder = -1;
		int iReleaseEkiOrder = -1;
		if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction && 
			iEnableOperation > 0)
		{
			iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
		}
		if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Junction &&
			iEnableOperation > 0)
		{
			iReleaseEkiOrder = pCentDedRessya->getFirstOperation().getReleaseEkiOrder();
		}
		for (int idx = m_CdYColSpecCont.getColumnNumber_Ekijikoku_begin();
			idx < m_CdYColSpecCont.getColumnNumber_Ekijikoku_end(); idx++)
		{
			const CdYColSpec aCdYColSpec = m_CdYColSpecCont.ColumnNumberToSpec(idx);

			CentDedEkiCont::CdDedEki aCdDedEki = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder());

			/**
				種別変更により、同一列に複数の列車を表示するとき、
				表示対象の列車を切り替えます。
				切り替えは、列車の有効終着駅の列車番号欄以降の描写を最初に行うときに行います。
			*/
			if (iRessyaIndex < (int)contCustomizeRessyaIndex.size() - 1 &&
				((aCdYColSpec.getColumnType() >= CdYColSpec::ColumnType_EkiRessyabangou &&
				aCdYColSpec.getEkiOrder() == iValidSyuuchakuEki) ||
				(aCdYColSpec.getEkiOrder() > iValidSyuuchakuEki &&
				iValidSyuuchakuEki != -1)))
			{
				iRessyaIndex++;
				pCentDedRessya = pCentDedRessyaCont->get(contCustomizeRessyaIndex[iRessyaIndex]);

				pCentDedRessyasyubetsu = pCentDedRessyasyubetsuContGet
					->get(pCentDedRessya->getRessyasyubetsuIndex());
				if (bDisplayParentSyubetsu && pCentDedRessyasyubetsu->getParentSyubetsuIndex() >= 0)
				{
					pCentDedRessyasyubetsu = pCentDedRessyasyubetsuContGet
						->get(pCentDedRessyasyubetsu->getParentSyubetsuIndex());
				}

				iSyubetsuChangeEkiOrder = iValidSyuuchakuEki;
				iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();

				if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Junction &&
					iEnableOperation > 0)
				{
					iConnectEkiOrder = pCentDedRessya->getLastOperation().getConnectEkiOrder();
				}
				iReleaseEkiOrder = -1;
			}


			CentDedEkiJikoku aCentDedEkiJikoku
				= pCentDedRessya->getCentDedEkiJikoku(aCdYColSpec.getEkiOrder());

			if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_Ekijikoku_Chaku)
			{
				tstring	strText = _T("");
				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				if (aCdYColSpec.getEkiOrder() < iValidSihatsuEki && iValidSihatsuEki != -1)
				{
					if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Outer
						&& bDisplayOuterTerminalShihatsu)
					{
						strText = m_nameKeiyunasi;

					}
					else if (iSyubetsuChangeEkiOrder != -1)
					{
						strText = m_nameKeiyunasi;
					}
					else if (aCdYColSpec.getEkiOrder() == iReleaseEkiOrder)
					{
						strText = m_nameRelease;
					}
					else if (iReleaseEkiOrder < aCdYColSpec.getEkiOrder() && iReleaseEkiOrder != -1)
					{
						strText = m_nameKeiyunasi;
					}
				}
				else if (aCdYColSpec.getEkiOrder() == iValidSihatsuEki)
				{
					if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Outer
						&& bDisplayOuterTerminalShihatsu)
					{
						if (aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka &&
							!bDisplayTsuukaEkiJikoku)
						{
							strText = m_nameKeiyunasi;
						}
						else
						{
							strText = encode_Ekijikoku(
								aCentDedEkiJikoku.getEkiatsukai(),
								pCentDedRessya->getFirstOperation().getChakuJikoku(),
								bDisplaySecondEkiJikoku,
								bDisplayColonEkiJikoku);
						}
					}
					else if (iSyubetsuChangeEkiOrder != -1 &&
						iSyubetsuChangeEkiOrder < aCdYColSpec.getEkiOrder())
					{
						//今後、設定で着時刻を入れられるようにする
						strText = m_nameKeiyunasi;
					}
					else if (iReleaseEkiOrder == aCdYColSpec.getEkiOrder() &&
						aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
					{
						strText = m_nameRelease;
					}
					//この駅が着時刻のみ表示の場合は、着時刻欄に発時刻を表示する
					else if (!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
					{
						CdDedJikoku aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();
						const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
						for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
						{
							const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
							if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt)
							{
								if (pAfterOperation->getIsDisplayHatsuJikoku())
								{
									aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
									break;
								}
							}
						}
						strText = encode_Ekijikoku(
							aCentDedEkiJikoku.getEkiatsukai(),
							aCdDedJikoku,
							bDisplaySecondEkiJikoku,
							bDisplayColonEkiJikoku);
					}
				}
				else if (aCdYColSpec.getEkiOrder() > iValidSyuuchakuEki && iValidSyuuchakuEki != -1)
				{
					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Outer
						&& bDisplayOuterTerminalShuchaku)
					{
						strText = m_nameKeiyunasi;

					}
					else if (iConnectEkiOrder >= aCdYColSpec.getEkiOrder() && iConnectEkiOrder != -1)
					{
						if (iConnectEkiOrder == aCdYColSpec.getEkiOrder() &&
							!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
						{
							strText = m_nameConnect;
						}
						else
						{
							strText = m_nameKeiyunasi;
						}
					}
					/**
						有効終着駅の次の駅で、この欄のすぐ上が発時刻欄かつ着時刻表示がない場合、
						この欄に"===="を描写します
						※csv出力での表示は保留。
					*/
					//if (aCdYColSpec.getEkiOrder() == iValidSyuuchakuEki + 1)
					//{
					//	CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumber - 1);
					//	CentDedEkiCont::CdDedEki aCdDedEkiPrev = muCdDedEki->get(aCdYColSpec.getEkiOrder() - 1);
					//	if (aCdYColSpecPrev.getEkiOrder() == aCdYColSpec.getEkiOrder() - 1 &&
					//		aCdYColSpecPrev.getColumnType() == CdYColSpec::ColumnType_Ekijikoku_Hatsu &&
					//		!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay())
					//	{
					//		//strText = _T("====");
					//	}
					//}
				}
				//中間及び終着駅の場合
				else
				{
					switch (aCentDedEkiJikoku.getEkiatsukai())
					{
						case CentDedEkiJikoku::Ekiatsukai_None:
						{
							strText = m_nameKeiyunasi;
						}
						break;
						case CentDedEkiJikoku::Ekiatsukai_Tsuuka:
						{
							CdDedJikoku aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();
							if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1))
							{
								/**
									前駅からこの駅間を運行している場合、基本的に着時刻を表示します。
									着時刻がある場合は、前作業を見て、「入換着時刻を当駅の着時刻にする」が有効になっている作業がある場合は、その作業で時刻を更新する。
									着時刻がない場合は、レ印を表示します。
								*/
								if (!aCdDedJikoku.isNull())
								{
									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
									for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									{
										const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
										if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
											iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pBeforeOperation->getIsDisplayChakuJikoku())
											{
												aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
												break;
											}
											/**
												getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
										}
									}
								}

								if (!aCdDedJikoku.isNull() &&
									(bDisplayTsuukaEkiJikoku ||
									(aCdYColSpec.getEkiOrder() == iValidSyuuchakuEki &&
										pCentDedRessya->getLastOperation().getAOperation() != CentDedAfterOperation::AOperation_Outer)))
								{
									//	通過駅の駅時刻が設定されており、
									//	『通過駅の駅時刻を表示する』指定になっている場合
									//	もしくは終着駅かつ路線外終着以外の場合は
									//	時刻を表示
									strText = encode_Ekijikoku(
										CentDedEkiJikoku::Ekiatsukai_Tsuuka,
										aCdDedJikoku,
										bDisplaySecondEkiJikoku,
										bDisplayColonEkiJikoku);
								}
								else
								{
									strText = m_nameTsuuka;
								}

							}
							else
							{
								/**
									前駅からこの駅間が運行していない場合は、基本的に経由無しを表示します。
									ただし、この駅に着時刻が設定されている場合、もしくはこの駅から次駅の間が運行ありかつ発時刻表示が無い場合は、
									着時刻を起点方から取得します。ただし、この駅から次駅の間が運行なしの場合は、
									終点方のisRunBetweenNextEkiがtrueの駅を探し、起点方の駅・この駅・終点方の駅が全て同一駅であることを確認してから、
									着時刻の取得を行います。
									上記探索において、着時刻が見つからなかった場合は、経由無しにしますが、
									この駅から次駅の間が運行ありかつ発時刻表示が無い場合は、レ印を表示します。
								*/
								if (!aCdDedJikoku.isNull() ||
									(pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) &&
										!aCdDedEki.getJikokuhyouHatsuJikokuDisplay()))
								{
									aCdDedJikoku.setNull();
									if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()))
									{
										int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(aCdYColSpec.getEkiOrder());
										if (pCentDedEkiCont->isSameBrunchLoopGroup(aCdYColSpec.getEkiOrder(), iChakuEkiOrder, pCentDedRessya->getRessyahoukou()))
										{
											CentDedEkiJikoku aChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
											aCdDedJikoku = aChakuEkiJikoku.getChakujikoku();
											int iRessyaTrack = aChakuEkiJikoku.getRessyaTrackIndex();
											const CentDedBeforeOperationCont* pBeforeCont = aChakuEkiJikoku.getCentDedBeforeOperationCont();
											for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
											{
												const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
												if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
													iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pBeforeOperation->getIsDisplayChakuJikoku())
													{
														aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
														break;
													}
													/**
														getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
												}
											}
										}
									}
									/**
										前後ともisRunBetweenNextEkiがFalseの場合は、一旦保留にします
										（番線欄や駅扱い一致、種別変更欄との兼ね合い及び、有効始発駅・終着駅より外側の表示と整合を合わせるため後回し
									*/
									//else
									//{
									//	int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
									//	int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
									//	if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()) &&
									//		pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
									//	{
									//		CentDedEkiJikoku aChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
									//		if (aCentDedEkiJikoku.getEkiatsukai() == aChakuEkiJikoku.getEkiatsukai())
									//		{
									//			/**
									//				前後ともisRunBetweenNextEkiがFalseの場合は、駅扱いが一致しているかどうかを確認します
									//				(列車編集時、iChakuEkiOrderとiHatsuEkiOrderは駅扱いを合わせるが、この駅は対象に入らないので)
									//				駅扱いが一致している場合のみ、時刻取得を行います。
									//			*/
									//			aCdDedJikoku = aChakuEkiJikoku.getChakujikoku();
									//			int iRessyaTrack = aChakuEkiJikoku.getRessyaTrackIndex();
									//			const CentDedBeforeOperationCont* pBeforeCont = aChakuEkiJikoku.getCentDedBeforeOperationCont();
									//			for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									//			{
									//				const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
									//				if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
									//					iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
									//				{
									//					/**
									//						同じ番線からの入換は、入換自体を無効と見なし、次を検索します
									//					*/
									//					if (pBeforeOperation->getIsDisplayChakuJikoku())
									//					{
									//						aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
									//						break;
									//					}
									//					/**
									//						getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
									//					*/
									//					iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
									//				}
									//			}
									//		}
									//	}
									//}
								}

								if (!aCdDedJikoku.isNull() &&
									bDisplayTsuukaEkiJikoku)
								{
									//	通過駅の駅時刻が設定されており、
									//	『通過駅の駅時刻を表示する』指定になっている場合は
									//	時刻を表示
									strText = encode_Ekijikoku(
										CentDedEkiJikoku::Ekiatsukai_Tsuuka,
										aCdDedJikoku,
										bDisplaySecondEkiJikoku,
										bDisplayColonEkiJikoku);
								}
								else if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) &&
									!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
								{
									strText = m_nameTsuuka;
								}
								else
								{
									strText = m_nameKeiyunasi;
								}
							}




							///**
							//	始発駅の次～終着駅において
							//	isRunBetweenNextEki(iEkiOrder-1)がfalseの場合は、
							//		その駅が着時刻のみ表示かつ、isRunBetweenNextEki(iEkiOrder)がtrueの場合を除き、
							//		駅時刻を表示せず、前駅の駅扱いに基づき、経由無しか運行無し表示を行います。
							//	着時刻のみ表示かつ着時刻がNULLで発時刻が有る場合は、発時刻を着時刻欄に表示します。

							//*/

							//if (!pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1) &&
							//	(!pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) ||
							//		aCdDedEki.getJikokuhyouHatsuJikokuDisplay()))
							//{
							//	strText = m_nameKeiyunasi;
							//}
							//else
							//{
							//	CdDedJikoku aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();
							//	//着時刻のみ表示駅かつ着時刻NULLの場合は、発時刻を取得します
							//	if (!aCdDedEki.getJikokuhyouHatsuJikokuDisplay() &&
							//		aCdDedJikoku.isNull())
							//	{
							//		aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();
							//		const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
							//		for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
							//		{
							//			const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
							//			if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt)
							//			{
							//				if (pAfterOperation->getIsDisplayHatsuJikoku())
							//				{
							//					aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
							//					break;
							//				}
							//			}
							//		}
							//	}
							//	//前作業を見て、「入換着時刻を当駅の着時刻にする」が有効になっている作業がある場合は、
							//	//その作業で時刻を更新する。
							//	else
							//	{
							//		int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
							//		const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
							//		for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
							//		{
							//			const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
							//			if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt)
							//			{
							//				/**
							//					同じ番線からの入換は、入換自体を無効と見なし、次を検索します
							//				*/
							//				if (iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
							//				{
							//					if (pBeforeOperation->getIsDisplayChakuJikoku())
							//					{
							//						aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
							//						break;
							//					}
							//					/**
							//						getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
							//					*/
							//					iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
							//				}
							//			}
							//		}

							//	}

							//	if (!aCdDedJikoku.isNull() &&
							//		(bDisplayTsuukaEkiJikoku || 
							//		(aCdYColSpec.getEkiOrder() == iValidSyuuchakuEki &&
							//			pCentDedRessya->getLastOperation().getAOperation() != CentDedAfterOperation::AOperation_Outer)))
							//	{
							//		//	通過駅の駅時刻が設定されており、
							//		//	『通過駅の駅時刻を表示する』指定になっている場合もしくは終着駅かつ路線外終着以外の場合は
							//		//	時刻を表示
							//		strText = encode_Ekijikoku(
							//			CentDedEkiJikoku::Ekiatsukai_Tsuuka,
							//			aCdDedJikoku,
							//			bDisplaySecondEkiJikoku,
							//			bDisplayColonEkiJikoku);
							//	}
							//	else
							//	{
							//		strText = m_nameTsuuka;
							//	}
							//}
						}
						break;
						case CentDedEkiJikoku::Ekiatsukai_Teisya:
						{
							CdDedJikoku aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();
							if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1))
							{
								/**
									前駅からこの駅間を運行している場合、基本的に着時刻を表示します。
									着時刻がある場合は、前作業を見て、「入換着時刻を当駅の着時刻にする」が有効になっている作業がある場合は、その作業で時刻を更新する。
									着時刻がない場合、この駅が着時刻のみ表示の場合は、発時刻を代わりに表示します。
									その場合、この駅から次駅の間が運行していない場合は、終点方のisRunBetweenNextEkiがtrueの駅を探し、
									この駅と同一駅の場合は、その駅から発時刻を取得します。
								*/
								if (!aCdDedJikoku.isNull())
								{
									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
									for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									{
										const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
										if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
											iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pBeforeOperation->getIsDisplayChakuJikoku())
											{
												aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
												break;
											}
											/**
												getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
										}
									}
								}

								if (aCdDedJikoku.isNull() &&
									!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
								{
									if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()))
									{
										aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();

										int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
										const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
										for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
										{
											const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
											if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
												iRessyaTrack != pAfterOperation->getShuntTrackIndex())
											{
												/**
													同じ番線からの入換は、入換自体を無効と見なし、次を検索します
												*/
												if (pAfterOperation->getIsDisplayHatsuJikoku())
												{
													aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
													break;
												}
												/**
													getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
												*/
												iRessyaTrack = pAfterOperation->getShuntTrackIndex();
											}
										}
									}
									else
									{
										int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(aCdYColSpec.getEkiOrder());
										if (pCentDedEkiCont->isSameBrunchLoopGroup(aCdYColSpec.getEkiOrder(), iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
										{
											CentDedEkiJikoku aHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
											aCdDedJikoku = aHatsuEkiJikoku.getHatsujikoku();
											int iRessyaTrack = aHatsuEkiJikoku.getRessyaTrackIndex();
											const CentDedAfterOperationCont* pAfterCont = aHatsuEkiJikoku.getCentDedAfterOperationCont();
											for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
											{
												const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
												if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
													iRessyaTrack != pAfterOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pAfterOperation->getIsDisplayHatsuJikoku())
													{
														aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
														break;
													}
													/**
														getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pAfterOperation->getShuntTrackIndex();
												}
											}
										}
									}
								}

								if (!aCdDedJikoku.isNull())
								{
									//	時刻が設定されている場合は時刻を表示
									strText = encode_Ekijikoku(
										CentDedEkiJikoku::Ekiatsukai_Teisya,
										aCdDedJikoku,
										bDisplaySecondEkiJikoku,
										bDisplayColonEkiJikoku);
								}
							}
							else
							{
								/**
									前駅からこの駅間が運行していない場合は、基本的に経由無しを表示します。
									ただし、この駅に着時刻が設定されている場合、もしくはこの駅から次駅の間が運行ありかつ発時刻表示が無い場合は、
									着時刻を起点方から取得します。ただし、この駅から次駅の間が運行なしの場合は、
									終点方のisRunBetweenNextEkiがtrueの駅を探し、起点方の駅・この駅・終点方の駅が全て同一駅であることを確認してから、
									着時刻の取得を行います。
									上記探索において、着時刻が見つからなかった場合は、経由無しにしますが、
									この駅から次駅の間が運行ありかつ発時刻表示が無い場合は、まず発時刻を表示するようにし、それもない場合は○印を表示します
								*/
								if (!aCdDedJikoku.isNull() ||
									(pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) &&
										!aCdDedEki.getJikokuhyouHatsuJikokuDisplay()))
								{
									aCdDedJikoku.setNull();
									if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()))
									{
										int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(aCdYColSpec.getEkiOrder());
										if (pCentDedEkiCont->isSameBrunchLoopGroup(aCdYColSpec.getEkiOrder(), iChakuEkiOrder, pCentDedRessya->getRessyahoukou()))
										{
											CentDedEkiJikoku aChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
											aCdDedJikoku = aChakuEkiJikoku.getChakujikoku();
											int iRessyaTrack = aChakuEkiJikoku.getRessyaTrackIndex();
											const CentDedBeforeOperationCont* pBeforeCont = aChakuEkiJikoku.getCentDedBeforeOperationCont();
											for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
											{
												const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
												if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
													iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pBeforeOperation->getIsDisplayChakuJikoku())
													{
														aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
														break;
													}
													/**
														getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
												}
											}
										}
									}
									/**
										前後ともisRunBetweenNextEkiがFalseの場合は、一旦保留にします
										（番線欄や駅扱い一致、種別変更欄との兼ね合い及び、有効始発駅・終着駅より外側の表示と整合を合わせるため後回し
									*/
									//else
									//{
									//	int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
									//	int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
									//	if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()) &&
									//		pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
									//	{
									//		CentDedEkiJikoku aChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
									//		if (aCentDedEkiJikoku.getEkiatsukai() == aChakuEkiJikoku.getEkiatsukai())
									//		{
									//			/**
									//				前後ともisRunBetweenNextEkiがFalseの場合は、駅扱いが一致しているかどうかを確認します
									//				(列車編集時、iChakuEkiOrderとiHatsuEkiOrderは駅扱いを合わせるが、この駅は対象に入らないので)
									//				駅扱いが一致している場合のみ、時刻取得を行います。
									//			*/
									//			aCdDedJikoku = aChakuEkiJikoku.getChakujikoku();
									//			int iRessyaTrack = aChakuEkiJikoku.getRessyaTrackIndex();
									//			const CentDedBeforeOperationCont* pBeforeCont = aChakuEkiJikoku.getCentDedBeforeOperationCont();
									//			for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									//			{
									//				const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
									//				if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
									//					iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
									//				{
									//					/**
									//						同じ番線からの入換は、入換自体を無効と見なし、次を検索します
									//					*/
									//					if (pBeforeOperation->getIsDisplayChakuJikoku())
									//					{
									//						aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
									//						break;
									//					}
									//					/**
									//						getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
									//					*/
									//					iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
									//				}
									//			}
									//		}
									//	}
									//}
								}

								if (aCdDedJikoku.isNull() &&
									pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) &&
									!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
								{
									aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();

									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
									for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
									{
										const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
										if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
											iRessyaTrack != pAfterOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pAfterOperation->getIsDisplayHatsuJikoku())
											{
												aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
												break;
											}
											/**
												getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pAfterOperation->getShuntTrackIndex();
										}
									}
								}

								if (!aCdDedJikoku.isNull())
								{
									//	時刻が設定されている場合は時刻を表示
									strText = encode_Ekijikoku(
										CentDedEkiJikoku::Ekiatsukai_Teisya,
										aCdDedJikoku,
										bDisplaySecondEkiJikoku,
										bDisplayColonEkiJikoku);
								}
								else if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) &&
									!aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
								{
									//時刻表ビューでは○印表示ですが、ここでは無表示です
								}
								else
								{
									strText = m_nameKeiyunasi;
								}
							}



							///**
							//	始発駅の次～終着駅において
							//	isRunBetweenNextEki(iEkiOrder-1)がfalseの場合は、
							//		その駅が着時刻のみ表示かつ、isRunBetweenNextEki(iEkiOrder)がtrueの場合を除き、
							//		駅時刻を表示せず、前駅の駅扱いに基づき、経由無しか運行無し表示を行います。
							//	着時刻のみ表示かつ着時刻がNULLで発時刻が有る場合は、発時刻を着時刻欄に表示します。

							//*/

							//if (!pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1) &&
							//	(!pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) ||
							//		aCdDedEki.getJikokuhyouHatsuJikokuDisplay()))
							//{
							//	strText = m_nameKeiyunasi;
							//}
							//else
							//{
							//	CdDedJikoku aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();
							//	//着時刻のみ表示駅かつ着時刻NULLの場合は、発時刻を取得します
							//	if (!aCdDedEki.getJikokuhyouHatsuJikokuDisplay() &&
							//		aCdDedJikoku.isNull())
							//	{
							//		aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();
							//		const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
							//		for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
							//		{
							//			const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
							//			if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt)
							//			{
							//				if (pAfterOperation->getIsDisplayHatsuJikoku())
							//				{
							//					aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
							//					break;
							//				}
							//			}
							//		}
							//	}
							//	//前作業を見て、「入換着時刻を当駅の着時刻にする」が有効になっている作業がある場合は、
							//	//その作業で時刻を更新する。
							//	else
							//	{
							//		int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
							//		const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
							//		for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
							//		{
							//			const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
							//			if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt)
							//			{
							//				/**
							//					同じ番線からの入換は、入換自体を無効と見なし、次を検索します
							//				*/
							//				if (iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
							//				{
							//					if (pBeforeOperation->getIsDisplayChakuJikoku())
							//					{
							//						aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
							//						break;
							//					}
							//					/**
							//						getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
							//					*/
							//					iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
							//				}
							//			}
							//		}
							//	}

							//	if (!aCdDedJikoku.isNull())
							//	{
							//		//	時刻が設定されている場合は時刻を表示

							//		strText = encode_Ekijikoku(
							//			CentDedEkiJikoku::Ekiatsukai_Teisya,
							//			aCdDedJikoku,
							//			bDisplaySecondEkiJikoku,
							//			bDisplayColonEkiJikoku);
							//	}
							//}
						}
						break;
					}
				}

				/**
					次駅が解結駅の場合、この欄に↴印を表示することがあります
					(1)次駅が解結駅かつ有効な始発駅
					(2)次駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直下が、次駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() + 1 == iValidSihatsuEki &&
					aCdYColSpec.getEkiOrder() + 1 == iReleaseEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiNext = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() + 1);
					if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberNext = idx + 1;
						CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
						if (aCdYColSpecNext.getEkiOrder() == aCdYColSpec.getEkiOrder() + 1)
						{
							strText = m_nameRelease;
						}
					}
				}
				/**
					前駅が増結駅の場合、この欄に↳印を表示することがあります
					(1)前駅が増結駅かつ有効な終着駅
					(2)前駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直上が、前駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() - 1 == iValidSyuuchakuEki &&
					aCdYColSpec.getEkiOrder() - 1 == iConnectEkiOrder &&
					iValidSyuuchakuEki != -1)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiPrev = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() - 1);
					if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberPrev = idx - 1;
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
						if (aCdYColSpecPrev.getEkiOrder() == aCdYColSpec.getEkiOrder() - 1)
						{
							strText = m_nameConnect;
						}
					}
				}

				CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
				aRow.getCellCont()->insert(CdCsvCell(strText));
				pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
				iRowIndex++;
			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_Ekijikoku_Hatsu)
			{
				tstring	strText;

				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				if (aCdYColSpec.getEkiOrder() < iValidSihatsuEki && iValidSihatsuEki != -1)
				{
					if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Outer
						&& bDisplayOuterTerminalShihatsu)
					{
						strText = m_nameKeiyunasi;
					}
					else if (iSyubetsuChangeEkiOrder != -1)
					{
						strText = m_nameKeiyunasi;
					}
					else if (iReleaseEkiOrder <= aCdYColSpec.getEkiOrder() && iReleaseEkiOrder != -1)
					{
						/**
							解結駅かつ、着時刻表示がない場合は、発時刻欄に↴を表示する。
						*/
						if (aCdYColSpec.getEkiOrder() == iReleaseEkiOrder &&
							!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
						{
							strText = m_nameRelease;
						}
						else
						{
							strText = m_nameKeiyunasi;
						}
					}
				}
				else if (aCdYColSpec.getEkiOrder() == iValidSyuuchakuEki)
				{
					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Outer
						&& bDisplayOuterTerminalShuchaku)
					{
						if (aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka &&
							!bDisplayTsuukaEkiJikoku)
						{
							strText = m_nameKeiyunasi;
						}
						else
						{
							strText = encode_Ekijikoku(
								aCentDedEkiJikoku.getEkiatsukai(),
								pCentDedRessya->getLastOperation().getHatsuJikoku(),
								bDisplaySecondEkiJikoku,
								bDisplayColonEkiJikoku);
						}
					}
					else if (aCdYColSpec.getEkiOrder() == iConnectEkiOrder &&
						aCdDedEki.getJikokuhyouChakuJikokuDisplay())
					{
						strText = m_nameConnect;
					}
					//この駅が発時刻のみ表示の場合は、発時刻欄に着時刻を表示する
					else if (!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
					{
						CdDedJikoku aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();
						const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
						for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
						{
							const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
							if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt)
							{
								if (pBeforeOperation->getIsDisplayChakuJikoku())
								{
									aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
									break;
								}
							}
						}
						strText = encode_Ekijikoku(
							aCentDedEkiJikoku.getEkiatsukai(),
							aCdDedJikoku,
							bDisplaySecondEkiJikoku,
							bDisplayColonEkiJikoku);
					}
				}
				else if (aCdYColSpec.getEkiOrder() > iValidSyuuchakuEki && iValidSyuuchakuEki != -1)
				{
					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Outer
						&& bDisplayOuterTerminalShuchaku)
					{
						strText = m_nameKeiyunasi;
					}
					else if (iConnectEkiOrder > aCdYColSpec.getEkiOrder() && iConnectEkiOrder != -1)
					{
						strText = m_nameKeiyunasi;
					}
					else if (iConnectEkiOrder == aCdYColSpec.getEkiOrder())
					{
						strText = m_nameConnect;
					}
				}
				//始発駅及び中間駅の場合
				else
				{
					switch (aCentDedEkiJikoku.getEkiatsukai())
					{
						case CentDedEkiJikoku::Ekiatsukai_None:
						{
							strText = m_nameKeiyunasi;
						}
						break;
						case CentDedEkiJikoku::Ekiatsukai_Tsuuka:
						{
							CdDedJikoku aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();
							if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()))
							{
								/**
									この駅から次駅間を運行している場合、基本的に発時刻を表示します。
									発時刻がある場合は、後作業を見て、「入換発時刻を当駅の発時刻にする」が有効になっている作業がある場合は、その作業で時刻を更新する。
									発時刻がない場合は、レ印を表示します。
								*/
								if (!aCdDedJikoku.isNull())
								{
									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
									for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
									{
										const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
										if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
											iRessyaTrack != pAfterOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pAfterOperation->getIsDisplayHatsuJikoku())
											{
												aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
												break;
											}
											/**
												getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pAfterOperation->getShuntTrackIndex();
										}
									}
								}

								if (!aCdDedJikoku.isNull() &&
									(bDisplayTsuukaEkiJikoku ||
									(aCdYColSpec.getEkiOrder() == iValidSihatsuEki &&
										pCentDedRessya->getFirstOperation().getBOperation() != CentDedBeforeOperation::BOperation_Outer)))
								{
									//	通過駅の駅時刻が設定されており、
									//	『通過駅の駅時刻を表示する』指定になっている場合
									//	もしくは始発駅かつ路線外始発以外の場合は
									//	時刻を表示
									strText = encode_Ekijikoku(
										CentDedEkiJikoku::Ekiatsukai_Tsuuka,
										aCdDedJikoku,
										bDisplaySecondEkiJikoku,
										bDisplayColonEkiJikoku);
								}
								else
								{
									strText = m_nameTsuuka;
								}
							}
							else
							{
								/**
									この駅から次駅間が運行していない場合は、基本的に経由無しを表示します。
									ただし、この駅に発時刻が設定されている場合、もしくは前駅からこの駅の間が運行ありかつ着時刻表示が無い場合は、
									発時刻を終点方から取得します。ただし、前駅からこの駅の間が運行なしの場合は、
									起点方のisRunBetweenNextEkiがtrueの駅を探し、起点方の駅・この駅・終点方の駅が全て同一駅であることを確認してから、
									発時刻の取得を行います。
									上記探索において、発時刻が見つからなかった場合は、経由無しにしますが、
									前駅からこの駅の間が運行ありかつ着時刻表示が無い場合は、レ印を表示します
								*/
								if (!aCdDedJikoku.isNull() ||
									(pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1) &&
										!aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
								{
									aCdDedJikoku.setNull();
									if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1))
									{
										int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(aCdYColSpec.getEkiOrder());
										if (pCentDedEkiCont->isSameBrunchLoopGroup(aCdYColSpec.getEkiOrder(), iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
										{
											CentDedEkiJikoku aHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
											aCdDedJikoku = aHatsuEkiJikoku.getHatsujikoku();
											int iRessyaTrack = aHatsuEkiJikoku.getRessyaTrackIndex();
											const CentDedAfterOperationCont* pAfterCont = aHatsuEkiJikoku.getCentDedAfterOperationCont();
											for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
											{
												const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
												if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
													iRessyaTrack != pAfterOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pAfterOperation->getIsDisplayHatsuJikoku())
													{
														aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
														break;
													}
													/**
														getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pAfterOperation->getShuntTrackIndex();
												}
											}
										}
									}
									/**
										前後ともisRunBetweenNextEkiがFalseの場合は、一旦保留にします
										（番線欄や駅扱い一致、種別変更欄との兼ね合い及び、有効始発駅・終着駅より外側の表示と整合を合わせるため後回し
									*/
									//else
									//{
									//	int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
									//	int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
									//	if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()) &&
									//		pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
									//	{
									//		CentDedEkiJikoku aHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
									//		if (aCentDedEkiJikoku.getEkiatsukai() == aHatsuEkiJikoku.getEkiatsukai())
									//		{
									//			/**
									//				前後ともisRunBetweenNextEkiがFalseの場合は、駅扱いが一致しているかどうかを確認します
									//				(列車編集時、iChakuEkiOrderとiHatsuEkiOrderは駅扱いを合わせるが、この駅は対象に入らないので)
									//				駅扱いが一致している場合のみ、時刻取得を行います。
									//			*/
									//			aCdDedJikoku = aHatsuEkiJikoku.getHatsujikoku();
									//			int iRessyaTrack = aHatsuEkiJikoku.getRessyaTrackIndex();
									//			const CentDedAfterOperationCont* pAfterCont = aHatsuEkiJikoku.getCentDedAfterOperationCont();
									//			for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
									//			{
									//				const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
									//				if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
									//					iRessyaTrack != pAfterOperation->getShuntTrackIndex())
									//				{
									//					/**
									//						同じ番線からの入換は、入換自体を無効と見なし、次を検索します
									//					*/
									//					if (pAfterOperation->getIsDisplayHatsuJikoku())
									//					{
									//						aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
									//						break;
									//					}
									//					/**
									//						getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
									//					*/
									//					iRessyaTrack = pAfterOperation->getShuntTrackIndex();
									//				}
									//			}
									//		}
									//	}
									//}
								}

								if (!aCdDedJikoku.isNull() &&
									bDisplayTsuukaEkiJikoku)
								{
									//	通過駅の駅時刻が設定されており、
									//	『通過駅の駅時刻を表示する』指定になっている場合は
									//	時刻を表示
									strText = encode_Ekijikoku(
										CentDedEkiJikoku::Ekiatsukai_Tsuuka,
										aCdDedJikoku,
										bDisplaySecondEkiJikoku,
										bDisplayColonEkiJikoku);
								}
								else if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1) &&
									!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
								{
									strText = m_nameTsuuka;
								}
								else
								{
									strText = m_nameKeiyunasi;
								}
							}



							///**
							//	始発駅～終着駅の前において
							//	isRunBetweenNextEki(aCdYColSpec.getEkiOrder())がfalseかつ、
							//		その駅に着時刻表示があるもしくはisRunBetweenNextEki(aCdYColSpec.getEkiOrder()-1)がfalseの場合は、
							//		駅時刻を表示せず、次駅の駅扱いに基づき、経由無しか運行無し表示を行います。
							//	発時刻のみ表示かつ発時刻がNULLで着時刻が有る場合は、着時刻を発時刻欄に表示します。

							//*/

							//if (!pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) &&
							//	(!pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1) ||
							//		aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
							//{
							//	strText = m_nameKeiyunasi;
							//}
							//else
							//{
							//	CdDedJikoku aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();
							//	//発時刻のみ表示駅かつ発時刻NULLの場合は、着時刻を取得します
							//	if (!aCdDedEki.getJikokuhyouChakuJikokuDisplay() &&
							//		aCdDedJikoku.isNull())
							//	{
							//		aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();
							//		const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
							//		for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
							//		{
							//			const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
							//			if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt)
							//			{
							//				if (pBeforeOperation->getIsDisplayChakuJikoku())
							//				{
							//					aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
							//					break;
							//				}
							//			}
							//		}
							//	}
							//	//後作業を見て、「入換発時刻を当駅の発時刻にする」が有効になっている作業がある場合は、
							//	//その作業で時刻を更新する。
							//	else
							//	{
							//		int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
							//		const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
							//		for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
							//		{
							//			const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
							//			if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt)
							//			{
							//				/**
							//					同じ番線からの入換は、入換自体を無効と見なし、次を検索します
							//				*/
							//				if (iRessyaTrack != pAfterOperation->getShuntTrackIndex())
							//				{
							//					if (pAfterOperation->getIsDisplayHatsuJikoku())
							//					{
							//						aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
							//						break;
							//					}
							//					/**
							//						getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
							//					*/
							//					iRessyaTrack = pAfterOperation->getShuntTrackIndex();
							//				}
							//			}
							//		}
							//	}

							//	if (!aCdDedJikoku.isNull() &&
							//		(bDisplayTsuukaEkiJikoku || 
							//		(aCdYColSpec.getEkiOrder() == iValidSihatsuEki &&
							//			pCentDedRessya->getFirstOperation().getBOperation() != CentDedBeforeOperation::BOperation_Outer)))
							//	{
							//		//	通過駅の駅時刻が設定されており、
							//		//	『通過駅の駅時刻を表示する』指定になっている場合もしくは始発駅かつ路線外始発以外の場合は
							//		//	時刻を表示
							//		strText = encode_Ekijikoku(
							//			CentDedEkiJikoku::Ekiatsukai_Tsuuka,
							//			aCdDedJikoku,
							//			bDisplaySecondEkiJikoku,
							//			bDisplayColonEkiJikoku);
							//	}
							//	else
							//	{
							//		strText = m_nameTsuuka;
							//	}
							//}
						}
						break;
						case CentDedEkiJikoku::Ekiatsukai_Teisya:
						{
							CdDedJikoku aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();
							if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()))
							{
								/**
									この駅から次駅間を運行している場合、基本的に発時刻を表示します。
									発時刻がある場合は、後作業を見て、「入換発時刻を当駅の発時刻にする」が有効になっている作業がある場合は、その作業で時刻を更新する。
									発時刻がない場合は、○印を表示しますが、この駅が発時刻のみ表示の場合は、着時刻を代わりに表示します。
									その場合、前駅からこの駅間が運行していない場合は、起点方のisRunBetweenNextEkiがtrueの駅を探し、
									この駅と同一駅の場合は、その駅から着時刻を取得します。
								*/
								if (!aCdDedJikoku.isNull())
								{
									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
									for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
									{
										const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
										if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
											iRessyaTrack != pAfterOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pAfterOperation->getIsDisplayHatsuJikoku())
											{
												aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
												break;
											}
											/**
												getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pAfterOperation->getShuntTrackIndex();
										}
									}
								}
								if (aCdDedJikoku.isNull() &&
									!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
								{
									if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1))
									{
										aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();

										int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
										const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
										for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
										{
											const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
											if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
												iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
											{
												/**
													同じ番線からの入換は、入換自体を無効と見なし、次を検索します
												*/
												if (pBeforeOperation->getIsDisplayChakuJikoku())
												{
													aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
													break;
												}
												/**
													getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
												*/
												iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
											}
										}
									}
									else
									{
										int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(aCdYColSpec.getEkiOrder());
										if (pCentDedEkiCont->isSameBrunchLoopGroup(aCdYColSpec.getEkiOrder(), iChakuEkiOrder, pCentDedRessya->getRessyahoukou()))
										{
											CentDedEkiJikoku aChakuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iChakuEkiOrder);
											aCdDedJikoku = aChakuEkiJikoku.getChakujikoku();
											int iRessyaTrack = aChakuEkiJikoku.getRessyaTrackIndex();
											const CentDedBeforeOperationCont* pBeforeCont = aChakuEkiJikoku.getCentDedBeforeOperationCont();
											for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
											{
												const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
												if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
													iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pBeforeOperation->getIsDisplayChakuJikoku())
													{
														aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
														break;
													}
													/**
														getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
												}
											}
										}
									}
								}

								if (!aCdDedJikoku.isNull())
								{
									//	時刻が設定されている場合は時刻を表示
									strText = encode_Ekijikoku(
										CentDedEkiJikoku::Ekiatsukai_Teisya,
										aCdDedJikoku,
										bDisplaySecondEkiJikoku,
										bDisplayColonEkiJikoku);
								}
							}
							else
							{
								/**
									この駅から次駅間が運行していない場合は、基本的に経由無しを表示します。
									ただし、この駅に発時刻が設定されている場合、もしくは前駅からこの駅の間が運行ありかつ着時刻表示が無い場合は、
									発時刻を終点方から取得します。ただし、前駅からこの駅の間が運行なしの場合は、
									起点方のisRunBetweenNextEkiがtrueの駅を探し、起点方の駅・この駅・終点方の駅が全て同一駅であることを確認してから、
									発時刻の取得を行います。
									上記探索において、発時刻が見つからなかった場合は、経由無しにしますが、
									前駅からこの駅の間が運行ありかつ着時刻表示が無い場合は、まず着時刻を表示するようにし、それもない場合は○印を表示します
								*/
								if (!aCdDedJikoku.isNull() ||
									(pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1) &&
										!aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
								{
									aCdDedJikoku.setNull();
									if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1))
									{
										int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(aCdYColSpec.getEkiOrder());
										if (pCentDedEkiCont->isSameBrunchLoopGroup(aCdYColSpec.getEkiOrder(), iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
										{
											CentDedEkiJikoku aHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
											aCdDedJikoku = aHatsuEkiJikoku.getHatsujikoku();
											int iRessyaTrack = aHatsuEkiJikoku.getRessyaTrackIndex();
											const CentDedAfterOperationCont* pAfterCont = aHatsuEkiJikoku.getCentDedAfterOperationCont();
											for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
											{
												const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
												if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
													iRessyaTrack != pAfterOperation->getShuntTrackIndex())
												{
													/**
														同じ番線からの入換は、入換自体を無効と見なし、次を検索します
													*/
													if (pAfterOperation->getIsDisplayHatsuJikoku())
													{
														aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
														break;
													}
													/**
														getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
													*/
													iRessyaTrack = pAfterOperation->getShuntTrackIndex();
												}
											}
										}
									}
									/**
										前後ともisRunBetweenNextEkiがFalseの場合は、一旦保留にします
										（番線欄や駅扱い一致、種別変更欄との兼ね合い及び、有効始発駅・終着駅より外側の表示と整合を合わせるため後回し
									*/
									//else
									//{
									//	int iChakuEkiOrder = pCentDedRessya->getRunBetweenEkiBackward(iEkiOrder);
									//	int iHatsuEkiOrder = pCentDedRessya->getRunBetweenEkiForward(iEkiOrder);
									//	if (pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iChakuEkiOrder, pCentDedRessya->getRessyahoukou()) &&
									//		pCentDedEkiCont->isSameBrunchLoopGroup(iEkiOrder, iHatsuEkiOrder, pCentDedRessya->getRessyahoukou()))
									//	{
									//		CentDedEkiJikoku aHatsuEkiJikoku = pCentDedRessya->getCentDedEkiJikoku(iHatsuEkiOrder);
									//		if (aCentDedEkiJikoku.getEkiatsukai() == aHatsuEkiJikoku.getEkiatsukai())
									//		{
									//			/**
									//				前後ともisRunBetweenNextEkiがFalseの場合は、駅扱いが一致しているかどうかを確認します
									//				(列車編集時、iChakuEkiOrderとiHatsuEkiOrderは駅扱いを合わせるが、この駅は対象に入らないので)
									//				駅扱いが一致している場合のみ、時刻取得を行います。
									//			*/
									//			aCdDedJikoku = aHatsuEkiJikoku.getHatsujikoku();
									//			int iRessyaTrack = aHatsuEkiJikoku.getRessyaTrackIndex();
									//			const CentDedAfterOperationCont* pAfterCont = aHatsuEkiJikoku.getCentDedAfterOperationCont();
									//			for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
									//			{
									//				const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
									//				if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt &&
									//					iRessyaTrack != pAfterOperation->getShuntTrackIndex())
									//				{
									//					/**
									//						同じ番線からの入換は、入換自体を無効と見なし、次を検索します
									//					*/
									//					if (pAfterOperation->getIsDisplayHatsuJikoku())
									//					{
									//						aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
									//						break;
									//					}
									//					/**
									//						getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
									//					*/
									//					iRessyaTrack = pAfterOperation->getShuntTrackIndex();
									//				}
									//			}
									//		}
									//	}
									//}
								}

								if (aCdDedJikoku.isNull() &&
									pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1) &&
									!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
								{
									aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();

									int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
									const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
									for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
									{
										const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
										if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt &&
											iRessyaTrack != pBeforeOperation->getShuntTrackIndex())
										{
											/**
												同じ番線からの入換は、入換自体を無効と見なし、次を検索します
											*/
											if (pBeforeOperation->getIsDisplayChakuJikoku())
											{
												aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
												break;
											}
											/**
												getIsDisplayChakuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
											*/
											iRessyaTrack = pBeforeOperation->getShuntTrackIndex();
										}
									}
								}

								if (!aCdDedJikoku.isNull())
								{
									//	時刻が設定されている場合は時刻を表示
									strText = encode_Ekijikoku(
										CentDedEkiJikoku::Ekiatsukai_Teisya,
										aCdDedJikoku,
										bDisplaySecondEkiJikoku,
										bDisplayColonEkiJikoku);
								}
								else if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1) &&
									!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
								{

								}
								else
								{
									strText = m_nameKeiyunasi;
								}
							}




							///**
							//	始発駅～終着駅の前において
							//	isRunBetweenNextEki(aCdYColSpec.getEkiOrder())がfalseかつ、
							//		その駅に着時刻表示があるもしくはisRunBetweenNextEki(aCdYColSpec.getEkiOrder()-1)がfalseの場合は、
							//		駅時刻を表示せず、次駅の駅扱いに基づき、経由無しか運行無し表示を行います。
							//	発時刻のみ表示かつ発時刻がNULLで着時刻が有る場合は、着時刻を発時刻欄に表示します。

							//*/

							//if (!pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) &&
							//	(!pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1) ||
							//		aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
							//{
							//	strText = m_nameKeiyunasi;
							//}
							//else
							//{
							//	CdDedJikoku aCdDedJikoku = aCentDedEkiJikoku.getHatsujikoku();
							//	//発時刻のみ表示駅かつ発時刻NULLの場合は、着時刻を取得します
							//	if (!aCdDedEki.getJikokuhyouChakuJikokuDisplay() &&
							//		aCdDedJikoku.isNull())
							//	{
							//		aCdDedJikoku = aCentDedEkiJikoku.getChakujikoku();
							//		const CentDedBeforeOperationCont* pBeforeCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
							//		for (int idx = pBeforeCont->size() - 1; idx >= 0; idx--)
							//		{
							//			const CentDedBeforeOperation* pBeforeOperation = pBeforeCont->getMuPtr()->get(idx);
							//			if (pBeforeOperation->getBOperation() == CentDedBeforeOperation::BOperation_Shunt)
							//			{
							//				if (pBeforeOperation->getIsDisplayChakuJikoku())
							//				{
							//					aCdDedJikoku = pBeforeOperation->getOperationChakuJikoku(true);
							//					break;
							//				}
							//			}
							//		}
							//	}
							//	//後作業を見て、「入換発時刻を当駅の発時刻にする」が有効になっている作業がある場合は、
							//	//その作業で時刻を更新する。
							//	else
							//	{
							//		int iRessyaTrack = aCentDedEkiJikoku.getRessyaTrackIndex();
							//		const CentDedAfterOperationCont* pAfterCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
							//		for (int idx = 0; idx < (int)pAfterCont->size(); idx++)
							//		{
							//			const CentDedAfterOperation* pAfterOperation = pAfterCont->getMuPtr()->get(idx);
							//			if (pAfterOperation->getAOperation() == CentDedAfterOperation::AOperation_Shunt)
							//			{
							//				/**
							//					同じ番線からの入換は、入換自体を無効と見なし、次を検索します
							//				*/
							//				if (iRessyaTrack != pAfterOperation->getShuntTrackIndex())
							//				{
							//					if (pAfterOperation->getIsDisplayHatsuJikoku())
							//					{
							//						aCdDedJikoku = pAfterOperation->getOperationHatsuJikoku();
							//						break;
							//					}
							//					/**
							//						getIsDisplayHatsuJikokuがfalseの場合、iRessyaTrackを更新して、次を検索します
							//					*/
							//					iRessyaTrack = pAfterOperation->getShuntTrackIndex();
							//				}
							//			}
							//		}
							//	}

							//	if (!aCdDedJikoku.isNull())
							//	{
							//		//	駅時刻が設定されている場合は時刻を表示
							//		strText = encode_Ekijikoku(
							//			CentDedEkiJikoku::Ekiatsukai_Teisya,
							//			aCdDedJikoku,
							//			bDisplaySecondEkiJikoku,
							//			bDisplayColonEkiJikoku);
							//	}
							//}
						}
						break;
					}
				}
				/**
					次駅が解結駅の場合、この欄に↴印を表示することがあります
					(1)次駅が解結駅かつ有効な始発駅
					(2)次駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直下が、次駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() + 1 == iValidSihatsuEki &&
					aCdYColSpec.getEkiOrder() + 1 == iReleaseEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiNext = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() + 1);
					if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberNext = idx + 1;
						CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
						if (aCdYColSpecNext.getEkiOrder() == aCdYColSpec.getEkiOrder() + 1)
						{
							strText = m_nameRelease;
						}
					}
				}
				/**
					前駅が増結駅の場合、この欄に↳印を表示することがあります
					(1)前駅が増結駅かつ有効な終着駅
					(2)前駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直上が、前駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() - 1 == iValidSyuuchakuEki &&
					aCdYColSpec.getEkiOrder() - 1 == iConnectEkiOrder &&
					iValidSyuuchakuEki != -1)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiPrev = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() - 1);
					if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberPrev = idx - 1;
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
						if (aCdYColSpecPrev.getEkiOrder() == aCdYColSpec.getEkiOrder() - 1)
						{
							strText = m_nameConnect;
						}
					}
				}
				
				CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
				aRow.getCellCont()->insert(CdCsvCell(strText));
				pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
				iRowIndex++;
			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_Track)
			{
				tstring strText;
				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				if (aCdYColSpec.getEkiOrder() < iValidSihatsuEki && iValidSihatsuEki != -1)
				{
					if (pCentDedRessya->getFirstOperation().getBOperation() == CentDedBeforeOperation::BOperation_Outer
						&& bDisplayOuterTerminalShihatsu)
					{
						strText = m_nameKeiyunasi;

					}
					else if (iSyubetsuChangeEkiOrder != -1)
					{
						strText = m_nameKeiyunasi;
					}
					else if (iReleaseEkiOrder == aCdYColSpec.getEkiOrder() &&
						aCdDedEki.getJikokuhyouChakuJikokuDisplay())
					{
						strText = m_nameKeiyunasi;
					}
					else if (iReleaseEkiOrder < aCdYColSpec.getEkiOrder() && iReleaseEkiOrder != -1)
					{
						strText = m_nameKeiyunasi;
					}
				}
				else if (aCdYColSpec.getEkiOrder() > iValidSyuuchakuEki && iValidSyuuchakuEki != -1)
				{
					if (pCentDedRessya->getLastOperation().getAOperation() == CentDedAfterOperation::AOperation_Outer
						&& bDisplayOuterTerminalShuchaku)
					{
						strText = m_nameKeiyunasi;
					}
					else if (iConnectEkiOrder > aCdYColSpec.getEkiOrder() && iConnectEkiOrder != -1)
					{
						strText = m_nameKeiyunasi;
					}
					else if (iConnectEkiOrder == aCdYColSpec.getEkiOrder() &&
						aCdDedEki.getJikokuhyouHatsuJikokuDisplay())
					{
						strText = m_nameKeiyunasi;
					}
				}
				else if (aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None)
				{
					strText = m_nameKeiyunasi;
				}
				/**
					停車・通過の場合
					前後のいずれかが、停車または通過であるもしくは、
					路線の始発駅もしくは終着駅である
					(iEkiOrder==0の時に、isRunBetweenNextEki(iEkiOrder)がfalseな場合は、iValidSihatsuEkiが0にならない
						→iEkiOrder < iValidSihatsuEkiのif節に引っかかるから、終着駅の場合も同様)
				*/
				else if (aCdYColSpec.getEkiOrder() == 0 ||
					aCdYColSpec.getEkiOrder() == pCdDedEkiCont->size() - 1 ||
					pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder() - 1) ||
					pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()))
				{
					CentDedEkiCont::CdDedEki aCdDedEki = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder());
					CentDedEkiTrack2Cont aCentDedEkiTrack2Cont = aCdDedEki.getCentDedEkiTrack2Cont();

					strText = aCentDedEkiTrack2Cont.get(
						aCentDedEkiJikoku.getRessyaTrackIndex()).getTrackRyakusyou(pCentDedRessya->getRessyahoukou());
					/*int idxRessyasyubetsu
						= pCentDedRessya->getRessyasyubetsuIndex();
					*pCDcDrawCell = createCDcdEkijikoku(idxRessyasyubetsu);*/
				}
				/**
					前後ともにisRunBetweenNextEki=falseの場合、前駅が経由無しなら、この欄を経由無し表示にします。
				*/
				else
				{
					strText = m_nameKeiyunasi;
				}

				/**
					次駅が解結駅の場合、この欄に↴印を表示することがあります
					(1)次駅が解結駅かつ有効な始発駅
					(2)次駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直下が、次駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() + 1 == iValidSihatsuEki &&
					aCdYColSpec.getEkiOrder() + 1 == iReleaseEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiNext = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() + 1);
					if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberNext = idx + 1;
						CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
						if (aCdYColSpecNext.getEkiOrder() == aCdYColSpec.getEkiOrder() + 1)
						{
							strText = m_nameRelease;
						}
					}
				}
				/**
					前駅が増結駅の場合、この欄に↳印を表示することがあります
					(1)前駅が増結駅かつ有効な終着駅
					(2)前駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直上が、前駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() - 1 == iValidSyuuchakuEki &&
					aCdYColSpec.getEkiOrder() - 1 == iConnectEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiPrev = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() - 1);
					if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberPrev = idx - 1;
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
						if (aCdYColSpecPrev.getEkiOrder() == aCdYColSpec.getEkiOrder() - 1)
						{
							strText = m_nameConnect;
						}
					}
				}
				
				CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
				aRow.getCellCont()->insert(CdCsvCell(strText));
				pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
				iRowIndex++;
			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_EkiRessyabangou)
			{
				tstring strText; 
				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				if (iSyubetsuChangeEkiOrder != -1 &&
					aCdYColSpec.getEkiOrder() < iValidSihatsuEki)
				{
					strText = m_nameKeiyunasi;
				}
				else if (aCdYColSpec.getEkiOrder() < iValidSihatsuEki)
				{
					strText = _T("");
				}
				else if (iValidSihatsuEki == aCdYColSpec.getEkiOrder())
				{
					if (iSyubetsuChangeEkiOrder != -1 ||
						aCdDedEki.getJikokuhyouRessyabangouDisplay() == 2)
					{
						strText = pCentDedRessya->getRessyabangou();
					}
					else
					{
						strText = _T("");
					}
				}
				else if (iValidSihatsuEki < aCdYColSpec.getEkiOrder() &&
					aCdYColSpec.getEkiOrder() < iValidSyuuchakuEki)
				{
					if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) ||
						!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
					{
						if (aCdDedEki.getJikokuhyouRessyabangouDisplay() == 2)
						{
							strText = pCentDedRessya->getRessyabangou();
						}
						else
						{
							strText = _T("↓");
						}
					}
					else
					{
						strText = m_nameKeiyunasi;
					}
				}
				else if (iValidSyuuchakuEki <= aCdYColSpec.getEkiOrder())
				{
					strText = _T("");
				}

				/**
					次駅が解結駅の場合、この欄に↴印を表示することがあります
					(1)次駅が解結駅かつ有効な始発駅
					(2)次駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直下が、次駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() + 1 == iValidSihatsuEki &&
					aCdYColSpec.getEkiOrder() + 1 == iReleaseEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiNext = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() + 1);
					if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberNext = idx + 1;
						CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
						if (aCdYColSpecNext.getEkiOrder() == aCdYColSpec.getEkiOrder() + 1)
						{
							strText = m_nameRelease;
						}
					}
				}
				/**
					前駅が増結駅の場合、この欄に↳印を表示することがあります
					(1)前駅が増結駅かつ有効な終着駅
					(2)前駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直上が、前駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() - 1 == iValidSyuuchakuEki &&
					aCdYColSpec.getEkiOrder() - 1 == iConnectEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiPrev = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() - 1);
					if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberPrev = idx - 1;
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
						if (aCdYColSpecPrev.getEkiOrder() == aCdYColSpec.getEkiOrder() - 1)
						{
							strText = m_nameConnect;
						}
					}
				}

				CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
				aRow.getCellCont()->insert(CdCsvCell(strText));
				pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
				iRowIndex++;
			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_EkiOperationNumber)
			{
				tstring strText; 
				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				if (iSyubetsuChangeEkiOrder != -1 &&
					aCdYColSpec.getEkiOrder() < iValidSihatsuEki)
				{
					strText = m_nameKeiyunasi;
				}
				else if (aCdYColSpec.getEkiOrder() < iValidSihatsuEki)
				{
					strText = _T("");
				}
				else if (iValidSihatsuEki == aCdYColSpec.getEkiOrder())
				{
					if (iSyubetsuChangeEkiOrder != -1 ||
						aCdDedEki.getJikokuhyouOperationNumberDisplay() == 2)
					{
						strText = joinc('+', pCentDedRessya->getOperationNumber(aCdYColSpec.getEkiOrder()));
						//strText = strOperationNumber;
					}
					else
					{
						strText = _T("");
					}
				}
				else if (iValidSihatsuEki < aCdYColSpec.getEkiOrder() &&
					aCdYColSpec.getEkiOrder() < iValidSyuuchakuEki)
				{
					if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) ||
						!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
					{
						if (aCdDedEki.getJikokuhyouOperationNumberDisplay() == 2)
						{
							strText = joinc('+', pCentDedRessya->getOperationNumber(aCdYColSpec.getEkiOrder()));
							//strText = strOperationNumber;
						}
						else
						{
							strText = _T("↓");
						}
					}
					else
					{
						strText = m_nameKeiyunasi;
					}
				}
				else if (iValidSyuuchakuEki <= aCdYColSpec.getEkiOrder())
				{
					strText = _T("");
				}

				/**
					次駅が解結駅の場合、この欄に↴印を表示することがあります
					(1)次駅が解結駅かつ有効な始発駅
					(2)次駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直下が、次駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() + 1 == iValidSihatsuEki &&
					aCdYColSpec.getEkiOrder() + 1 == iReleaseEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiNext = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() + 1);
					if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberNext = idx + 1;
						CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
						if (aCdYColSpecNext.getEkiOrder() == aCdYColSpec.getEkiOrder() + 1)
						{
							strText = m_nameRelease;
						}
					}
				}
				/**
					前駅が増結駅の場合、この欄に↳印を表示することがあります
					(1)前駅が増結駅かつ有効な終着駅
					(2)前駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直上が、前駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() - 1 == iValidSyuuchakuEki &&
					aCdYColSpec.getEkiOrder() - 1 == iConnectEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiPrev = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() - 1);
					if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberPrev = idx - 1;
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
						if (aCdYColSpecPrev.getEkiOrder() == aCdYColSpec.getEkiOrder() - 1)
						{
							strText = m_nameConnect;
						}
					}
				}
				CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
				aRow.getCellCont()->insert(CdCsvCell(strText));
				pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
				iRowIndex++;

			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_EkiRessyasyubetsu)
			{
				tstring strText;

				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
				{
					strText = _T("");
				}
				else if (iSyubetsuChangeEkiOrder != -1 &&
					aCdYColSpec.getEkiOrder() < iValidSihatsuEki)
				{
					strText = m_nameKeiyunasi;
				}
				else if (aCdYColSpec.getEkiOrder() < iValidSihatsuEki)
				{
					strText = _T("");
				}
				else if (iValidSihatsuEki == aCdYColSpec.getEkiOrder())
				{
					if (iSyubetsuChangeEkiOrder != -1 ||
						aCdDedEki.getJikokuhyouRessyaSyubetsuDisplay() == 2)
					{
						strText = pCentDedRessyasyubetsu->getRyakusyou();
					}
					else
					{
						strText = _T("");
					}
				}
				else if (iValidSihatsuEki < aCdYColSpec.getEkiOrder() &&
					aCdYColSpec.getEkiOrder() < iValidSyuuchakuEki)
				{
					if (pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) ||
						!aCdDedEki.getJikokuhyouChakuJikokuDisplay())
					{
						if (aCdDedEki.getJikokuhyouRessyaSyubetsuDisplay() == 2)
						{
							strText = pCentDedRessyasyubetsu->getRyakusyou();
						}
						else
						{
							strText = _T("↓");
						}
					}
					else
					{
						strText = m_nameKeiyunasi;
					}
				}
				else if (iValidSyuuchakuEki <= aCdYColSpec.getEkiOrder())
				{
					strText = _T("");
				}
				/**
					次駅が解結駅の場合、この欄に↴印を表示することがあります
					(1)次駅が解結駅かつ有効な始発駅
					(2)次駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直下が、次駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() + 1 == iValidSihatsuEki &&
					aCdYColSpec.getEkiOrder() + 1 == iReleaseEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiNext = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() + 1);
					if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberNext = idx + 1;
						CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
						if (aCdYColSpecNext.getEkiOrder() == aCdYColSpec.getEkiOrder() + 1)
						{
							strText = m_nameRelease;
						}
					}
				}
				/**
					前駅が増結駅の場合、この欄に↳印を表示することがあります
					(1)前駅が増結駅かつ有効な終着駅
					(2)前駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直上が、前駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() - 1 == iValidSyuuchakuEki &&
					aCdYColSpec.getEkiOrder() - 1 == iConnectEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiPrev = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() - 1);
					if (!aCdDedEkiPrev.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiPrev.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberPrev = idx - 1;
						CdYColSpec aCdYColSpecPrev = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberPrev);
						if (aCdYColSpecPrev.getEkiOrder() == aCdYColSpec.getEkiOrder() - 1)
						{
							strText = m_nameConnect;
						}
					}
				}
				CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
				aRow.getCellCont()->insert(CdCsvCell(strText));
				pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
				iRowIndex++;

			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_EkiRessyamei)
			{
				tstring strText;
				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
				{
					strText = _T("");
				}
				else if (iValidSihatsuEki == aCdYColSpec.getEkiOrder())
				{
					if (iSyubetsuChangeEkiOrder != -1 ||
						aCdDedEki.getJikokuhyouRessyameiDisplay() == 2)
					{
						strText = pCentDedRessya->getRessyamei();
					}
				}
				else if (iValidSihatsuEki < aCdYColSpec.getEkiOrder() &&
					aCdYColSpec.getEkiOrder() < iValidSyuuchakuEki &&
					aCdDedEki.getJikokuhyouRessyameiDisplay() == 2 &&
					(pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) ||
						!aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
				{
					strText = pCentDedRessya->getRessyamei();
				}
				CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
				aRow.getCellCont()->insert(CdCsvCell(strText));
				pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
				iRowIndex++;

			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_EkiGousuu)
			{
				tstring strText;
				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
				{
					strText = _T("");
				}
				else if (iValidSihatsuEki == aCdYColSpec.getEkiOrder())
				{
					if (iSyubetsuChangeEkiOrder != -1 ||
						aCdDedEki.getJikokuhyouRessyameiDisplay() == 2)
					{
						strText = pCentDedRessya->getGousuu();
					}
				}
				else if (iValidSihatsuEki < aCdYColSpec.getEkiOrder() &&
					aCdYColSpec.getEkiOrder() < iValidSyuuchakuEki &&
					aCdDedEki.getJikokuhyouRessyameiDisplay() == 2 &&
					(pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) ||
						!aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
				{
					strText = pCentDedRessya->getGousuu();
				}
				CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
				aRow.getCellCont()->insert(CdCsvCell(strText));
				pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
				iRowIndex++;

			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_EkiGou)
			{
				int iValidSihatsuEki = pCentDedRessya->getValidSihatsuEki();
				int iValidSyuuchakuEki = pCentDedRessya->getValidSyuuchakuEki();
				tstring strText;
				if (iValidSihatsuEki == -1 || iValidSyuuchakuEki == -1)
				{
					strText = _T("");
				}
				else if (pCentDedRessya->getGousuu().empty())
				{
					strText = _T("");
				}
				else if (iValidSihatsuEki == aCdYColSpec.getEkiOrder())
				{
					if (iSyubetsuChangeEkiOrder != -1 ||
						aCdDedEki.getJikokuhyouRessyameiDisplay() == 2)
					{
						strText = m_nameGou;
					}
				}
				else if (iValidSihatsuEki < aCdYColSpec.getEkiOrder() &&
					aCdYColSpec.getEkiOrder() < iValidSyuuchakuEki &&
					aCdDedEki.getJikokuhyouRessyameiDisplay() == 2 &&
					(pCentDedRessya->isRunBetweenNextEki(aCdYColSpec.getEkiOrder()) ||
						!aCdDedEki.getJikokuhyouChakuJikokuDisplay()))
				{
					if (aCdDedEki.getJikokuhyouRessyameiDisplay() == 2)
					{
						strText = m_nameGou;
					}
				}

				/**
					次駅が解結駅の場合、この欄に↴印を表示することがあります
					(1)次駅が解結駅かつ有効な始発駅
					(2)次駅が着時刻又は発時刻のどちらかのみ表示
					(3)この欄の直下が、次駅の項な場合。
				*/
				if (aCdYColSpec.getEkiOrder() + 1 == iValidSihatsuEki &&
					aCdYColSpec.getEkiOrder() + 1 == iReleaseEkiOrder)
				{
					CentDedEkiCont::CdDedEki aCdDedEkiNext = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder() + 1);
					if (!aCdDedEkiNext.getJikokuhyouChakuJikokuDisplay() ||
						!aCdDedEkiNext.getJikokuhyouHatsuJikokuDisplay())
					{
						int iYColumnNumberNext = idx + 1;
						CdYColSpec aCdYColSpecNext = m_CdYColSpecCont.ColumnNumberToSpec(iYColumnNumberNext);
						if (aCdYColSpecNext.getEkiOrder() == aCdYColSpec.getEkiOrder() + 1)
						{
							strText = m_nameRelease;
						}
					}
				}
				CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
				aRow.getCellCont()->insert(CdCsvCell(strText));
				pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
				iRowIndex++;

			}
		}
	}

	//＜2.17＞ <路線外終着駅>
	if (iRv >= 0 && bDisplayOuterTerminalShuchaku)
	{
		tstring strText1;
		tstring strText2;

		const CentDedAfterOperation aLastOperation = pCentDedRessya->getLastOperation();
		if (aLastOperation.getAOperation() == CentDedAfterOperation::AOperation_Outer)
		{
			CentDedEkiCont::CdDedEki aCdDedEki = pCdDedEkiCont->get(pCentDedRessya->getValidSyuuchakuEki());
			strText1 = aCdDedEki.getOuterTerminalJikokuRyaku(aLastOperation.getOuterShuchakuekiIndex(), true);

			if (!(aLastOperation.getOuterShuchakuJikoku().isNull()))
			{
				CdDedJikoku aCdDedJikoku
					= aLastOperation.getOuterShuchakuJikoku();
				strText2 = encode_Ekijikoku(
					CentDedEkiJikoku::Ekiatsukai_Teisya,
					aCdDedJikoku,
					bDisplaySecondEkiJikoku,
					bDisplayColonEkiJikoku);
			}
		}

		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell(strText1));
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
		CdCsvRow	aRow2 = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow2.getCellCont()->insert(CdCsvCell(strText2));
		pCdCsvDocument->getRowCont()->set(aRow2, iRowIndex);
		iRowIndex++;
	}
	//＜2.11＞[列1="備考" AND 列2=""]の列　備考列
	if ( iRv >= 0 )
	{
			CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
			aRow.getCellCont()->insert( CdCsvCell( pCentDedRessya->getBikou() ) ) ;
			pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
	}
	return iRv ;
}

int CconvJikokuhyouCustomizeCsv::encode_AddRessyaNull(
	CdCsvDocument* pCdCsvDocument,
	const bool bDisplayShihatsuShuchakuEkimei,
	const bool bDisplayRessyamei,
	const int iEnableOperation,
	const bool bDisplayOuterTerminalShihatsu,
	const bool bDisplayOuterTerminalShuchaku)
{
	int iRv = 0 ;
	// --------------------------------

	int iRowIndex = CSVROWINDEX_Ressyabangou;
	//＜2.5＞5行目 <列車番号>
	if ( iRv >= 0 )
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
		aRow.getCellCont()->insert( CdCsvCell() ) ;
		pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
		iRowIndex++;
	}

	//＜2.6＞ <運用番号>
	if (iRv >= 0 && iEnableOperation>1)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
	}

	//＜2.6＞6行目 <列車種別>
	if ( iRv >= 0 )
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
		aRow.getCellCont()->insert( CdCsvCell() ) ;
		pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
		iRowIndex++;
	}

	//＜2.7＞7行目 <列車名>
	if ( iRv >= 0 && bDisplayRessyamei)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
		aRow.getCellCont()->insert( CdCsvCell() ) ;
		pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
		iRowIndex++;
	}

	//＜2.8＞8行目 <号数>
	if ( iRv >= 0 && bDisplayRessyamei)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
		aRow.getCellCont()->insert( CdCsvCell() ) ;
		pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
		iRowIndex++;
	}
	//＜2.9＞9行目 <号表示>
	if ( iRv >= 0 && bDisplayRessyamei)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
		aRow.getCellCont()->insert( CdCsvCell() ) ;
		pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
		iRowIndex++;
	}

	//＜2.11＞ <始発駅名>
	if (iRv >= 0 && bDisplayShihatsuShuchakuEkimei)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
	}
	
	//＜2.13＞ <終着駅名>
	if (iRv >= 0 && bDisplayShihatsuShuchakuEkimei)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
	}

	//＜2.15＞ <路線外始発駅>
	if (iRv >= 0 && bDisplayOuterTerminalShihatsu)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
		CdCsvRow	aRow2 = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow2.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->set(aRow2, iRowIndex);
		iRowIndex++;
	}
	//＜2.16＞10行目～ 駅時刻
	
	//contiJikokuOrderOfJikokuhyouIndex = 
	//	 contiJikokuOrderOfJjikokuhyouIndex[<時刻表Index>]=<時刻Order> の法則を持ちます。
	//	要素の数は、時刻表の列数です。

	if ( iRv >= 0 )
	{
		for (int idx = m_CdYColSpecCont.getColumnNumber_Ekijikoku_begin();
			idx < m_CdYColSpecCont.getColumnNumber_Ekijikoku_end(); idx++)
		{
			CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
			aRow.getCellCont()->insert( CdCsvCell(  ) ) ;
			pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
			iRowIndex++;
		}
	}
	//＜2.17＞ <路線外終着駅>
	if (iRv >= 0 && bDisplayOuterTerminalShuchaku)
	{
		CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->set(aRow, iRowIndex);
		iRowIndex++;
		CdCsvRow	aRow2 = pCdCsvDocument->getRowCont()->get(iRowIndex);
		aRow2.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->set(aRow2, iRowIndex);
		iRowIndex++;
	}
	//＜2.18＞[列1="備考" AND 列2=""]の列　備考列
	if ( iRv >= 0 )
	{
			CdCsvRow	aRow = pCdCsvDocument->getRowCont()->get(iRowIndex) ;
			aRow.getCellCont()->insert( CdCsvCell() ) ;
			pCdCsvDocument->getRowCont()->set( aRow , iRowIndex) ;
	}
	return iRv ;
}

	// ********************************
	//	コンストラクタ
	// ********************************
CconvJikokuhyouCustomizeCsv::CconvJikokuhyouCustomizeCsv(
		const tstring& nameKudari ,
		const tstring& nameNobori ,
		const tstring& nameRessyabangou ,
		const tstring& nameRessyasyubetsu ,
		const tstring& nameRessyamei ,
		const tstring& nameGousuu ,
		const tstring& nameGou ,
		const tstring& nameBikou ,
		const tstring& nameChaku ,
		const tstring& nameHatsu ,
		const tstring& nameTsuuka ,
		const tstring& nameKeiyunasi,
		const tstring& nameTrack,
		const tstring& nameOperationNumber,
		const tstring& nameShihatsuEkimei,
		const tstring& nameOperation_Shihatsu,
		const tstring& nameShuchakuEkimei,
		const tstring& nameOperation_Shuchaku,
		const tstring& nameJikoku,
		const tstring& nameBeforeOperation,
		const tstring& nameAfterOperation) :
	m_nameKudari( nameKudari ) , 
	m_nameNobori( nameNobori ) ,
	m_nameRessyabangou( nameRessyabangou ),
	m_nameRessyasyubetsu( nameRessyasyubetsu ),
	m_nameRessyamei( nameRessyamei ),
	m_nameGousuu( nameGousuu ),
	m_nameGou( nameGou ),
	m_nameBikou( nameBikou ) ,
	m_nameChaku( nameChaku ) ,
	m_nameHatsu( nameHatsu ) ,
	m_nameTsuuka( nameTsuuka ) ,
	m_nameKeiyunasi( nameKeiyunasi ),
	m_nameTrack(nameTrack),
	m_nameOperationNumber(nameOperationNumber),
	m_nameShihatsuEkimei(nameShihatsuEkimei),
	m_nameOperation_Shihatsu(nameOperation_Shihatsu),
	m_nameShuchakuEkimei(nameShuchakuEkimei),
	m_nameOperation_Shuchaku(nameOperation_Shuchaku),
	m_nameJikoku(nameJikoku),
	m_nameBeforeOperation(nameBeforeOperation),
	m_nameAfterOperation(nameAfterOperation)
{
}


	// ********************************
	//@name	CconvJikokuhyouCustomizeCsv
	// ********************************
int CconvJikokuhyouCustomizeCsv::encode( 
		const CentDedRosen& aCentDedRosen , 
		int iDiaIndex , 
		ERessyahoukou eRessyahoukou ,
		int iRessyaIndex , int iRessyaCount ,
		const bool bDisplayTsuukaEkiJikoku,
		const bool bDisplaySecondEkiJikoku,
		const bool bDisplayColonEkiJikoku,
		const bool bDisplayShihatsuShuchakuEkimei,
		const bool bDisplayParentSyubetsu,
		const bool bDisplayRessyamei,
		const int iEnableOperation,
		const bool bDisplayOuterTerminalShihatsu,
		const bool bDisplayOuterTerminalShuchaku,
		CdCsvDocument* pCdCsvDocument ) 
{
	int iRv = 0 ;
	
	const CentDedEkiCont* pCentDedEkiCont = NULL ;
	const Mu<CentDedEkiCont::CdDedEki>* pCdDedEkiCont = NULL ;
	const Mu<const CentDedRessyasyubetsu*>* pCentDedRessyasyubetsuContGet = NULL ;
	const CentDedDia* pCentDedDia = NULL ;
	const Mu<const CentDedRessya*>* pCentDedRessyaCont = NULL ;

	// --------------------------------
	//	オブジェクトCdCsvDocument をクリア
	// --------------------------------
	if ( iRv >= 0 )
	{
		pCentDedEkiCont = aCentDedRosen.getCentDedEkiCont() ;
		pCdDedEkiCont = aCentDedRosen.getCentDedEkiCont()
			->getMuPtr( eRessyahoukou ) ;
		pCentDedRessyasyubetsuContGet = aCentDedRosen.getCentDedRessyasyubetsuCont()->getMuPtr() ; 
		pCentDedDia = aCentDedRosen.getCentDedDiaCont()->getMuPtr()->get( iDiaIndex ) ;
		if ( pCentDedDia == NULL )
		{
			iRv = -1 ;	//	iDiaIndex が不正です。
		}
	}
	const vector<vector<int>>& contCustomizeRessyaIndex = pCentDedDia->getcontCustomizeRessyaIndex(eRessyahoukou);
	if ( iRv >= 0 )
	{
		pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( eRessyahoukou )->getMuPtr() ;
	}
	//pCentDedRessyaCont = 列車のコンテナ
	if ( iRv >= 0 )
	{
		if ( !( 0 <= iRessyaIndex && iRessyaIndex < (int)contCustomizeRessyaIndex.size() )
			&& iRessyaIndex != 0 )
		{
			iRv = -2 ;	//	iRessyaIndex が不正です。
		}
	}
	if ( iRv >= 0 )
	{
		if ( iRessyaCount == INT_MAX )
		{
			iRessyaCount = pCentDedRessyaCont->size() - iRessyaIndex ;
		}
		if ( !( 0 <= iRessyaIndex + iRessyaCount && 
			iRessyaIndex + iRessyaCount <= (int)contCustomizeRessyaIndex.size()) )
		{
			iRv = -3 ;	//	iRessyaCount が不正です。
		}
	}

	// --------------------------------
	//	CdCsvDocument をクリア
	// --------------------------------
	if ( iRv >= 0 )
	{
		pCdCsvDocument->getRowCont()->erase( 0 , INT_MAX ) ;
	}

	// --------------------------------
	//	ヘッダ列
	// --------------------------------
	//	1行目 FileType行
	if ( iRv >= 0 )
	{
		CdCsvRow	aRow ;
		aRow.getCellCont()->insert( CdCsvCell( nameFileType ) ) ;
		aRow.getCellCont()->insert( CdCsvCell( nameFileTypeValue ) ) ;
		pCdCsvDocument->getRowCont()->insert( aRow ) ;
	}	
	//	2行目 DiaName行
	if ( iRv >= 0 )
	{
		CdCsvRow	aRow ;
		aRow.getCellCont()->insert( CdCsvCell( pCentDedDia->getName() ) ) ;
		pCdCsvDocument->getRowCont()->insert( aRow ) ;
	}	
	//＜2.3＞ 3行目 <下り,上り>
	if ( iRv >= 0 )
	{
		tstring strValue ;
		if ( eRessyahoukou == Ressyahoukou_Kudari )
		{
			strValue = m_nameKudari ;
		}
		else
		{
			strValue = m_nameNobori ;
		}
		strValue += _T("カスタマイズ");
		
		CdCsvRow	aRow ;
		aRow.getCellCont()->insert( CdCsvCell( strValue ) ) ;
		pCdCsvDocument->getRowCont()->insert( aRow ) ;
	}
	//＜2.4＞4行目 
	if ( iRv >= 0 )
	{
		CdCsvRow	aRow ;
		pCdCsvDocument->getRowCont()->insert( aRow ) ;
	}

	// --------------------------------
	//	時刻表部分の左側2列
	// --------------------------------
	//＜2.5＞5行目 <列車番号>
	if ( iRv >= 0 )
	{
		CdCsvRow	aRow ;
		aRow.getCellCont()->insert( CdCsvCell( m_nameRessyabangou ) ) ;
		aRow.getCellCont()->insert( CdCsvCell( ) ) ;
		pCdCsvDocument->getRowCont()->insert( aRow ) ;
	}

	//＜2.6＞6行目 <運用番号>
	if (iRv >= 0 && iEnableOperation > 1)
	{
		CdCsvRow	aRow;
		aRow.getCellCont()->insert(CdCsvCell(m_nameOperationNumber));
		aRow.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->insert(aRow);
	}

	//＜2.7＞7行目 <列車種別>
	if ( iRv >= 0 )
	{
		CdCsvRow	aRow ;
		aRow.getCellCont()->insert( CdCsvCell( m_nameRessyasyubetsu ) ) ;
		aRow.getCellCont()->insert( CdCsvCell( ) ) ;
		pCdCsvDocument->getRowCont()->insert( aRow ) ;
	}

	//＜2.8＞8行目 <列車名>
	if ( iRv >= 0 && bDisplayRessyamei)
	{
		CdCsvRow	aRow ;
		aRow.getCellCont()->insert( CdCsvCell( m_nameRessyamei ) ) ;
		aRow.getCellCont()->insert( CdCsvCell( ) ) ;
		pCdCsvDocument->getRowCont()->insert( aRow ) ;
	}

	//＜2.9＞9行目 <号数>
	if ( iRv >= 0 && bDisplayRessyamei)
	{
		CdCsvRow	aRow ;
		aRow.getCellCont()->insert( CdCsvCell( m_nameGousuu ) ) ;
		aRow.getCellCont()->insert( CdCsvCell( ) ) ;
		pCdCsvDocument->getRowCont()->insert( aRow ) ;
	}
	//＜2.10＞10行目 <号表示>
	if ( iRv >= 0 && bDisplayRessyamei)
	{
		CdCsvRow	aRow ;
		aRow.getCellCont()->insert( CdCsvCell() ) ;
		aRow.getCellCont()->insert( CdCsvCell() ) ;
		pCdCsvDocument->getRowCont()->insert( aRow ) ;
	}
	//＜2.11＞11行目 <始発駅名>
	if (iRv >= 0 && bDisplayShihatsuShuchakuEkimei)
	{
		CdCsvRow	aRow;
		aRow.getCellCont()->insert(CdCsvCell(m_nameShihatsuEkimei));
		aRow.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->insert(aRow);
	}
	//＜2.13＞13行目 <終着駅名>
	if (iRv >= 0 && bDisplayShihatsuShuchakuEkimei)
	{
		CdCsvRow	aRow;
		aRow.getCellCont()->insert(CdCsvCell(m_nameShuchakuEkimei));
		aRow.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->insert(aRow);
	}
	//＜2.15＞15行目 <路線外始発駅>
	if (iRv >= 0 && bDisplayOuterTerminalShihatsu)
	{
		CdCsvRow	aRow;
		aRow.getCellCont()->insert(CdCsvCell(m_nameShihatsuEkimei));
		aRow.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->insert(aRow);
		CdCsvRow	aRow2;
		aRow2.getCellCont()->insert(CdCsvCell(m_nameJikoku));
		aRow2.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->insert(aRow2);
	}

	//始発駅・終着駅
	//路線外始発
	//前後作業
	//＜2.16＞16行目～ 駅時刻
	if (iRv >= 0)
	{
		m_CdYColSpecCont =
			CdYColSpecCont(
				pCentDedEkiCont, eRessyahoukou,
				false, //AllJikoku
				true, //Customize
				false, //ShihatsuShuchakuEkimei
				true,  //Ressyamei
				iEnableOperation, //Operation
				false, //OuterShihatsu
				false);//OuterSyuchaku

		for (int idx = m_CdYColSpecCont.getColumnNumber_Ekijikoku_begin();
			idx < m_CdYColSpecCont.getColumnNumber_Ekijikoku_end(); idx++)
		{
			CdYColSpec aCdYColSpec = m_CdYColSpecCont.ColumnNumberToSpec(idx);

			CentDedEkiCont::CdDedEki aCdDedEki = pCdDedEkiCont->get(aCdYColSpec.getEkiOrder());

			tstring	strEkimei = aCdDedEki.getEkimei();
			tstring	strChakuHatsu;
			if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_Ekijikoku_Chaku)
			{
				strChakuHatsu = m_nameChaku;
				CdCsvRow	aRow;
				aRow.getCellCont()->insert(CdCsvCell(strEkimei));
				aRow.getCellCont()->insert(CdCsvCell(strChakuHatsu));
				pCdCsvDocument->getRowCont()->insert(aRow);
			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_Ekijikoku_Hatsu)
			{
				strChakuHatsu = m_nameHatsu;
				CdCsvRow	aRow;
				aRow.getCellCont()->insert(CdCsvCell(strEkimei));
				aRow.getCellCont()->insert(CdCsvCell(strChakuHatsu));
				pCdCsvDocument->getRowCont()->insert(aRow);
			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_Track)
			{
				strChakuHatsu = m_nameTrack;
				CdCsvRow	aRow;
				aRow.getCellCont()->insert(CdCsvCell(strEkimei));
				aRow.getCellCont()->insert(CdCsvCell(strChakuHatsu));
				pCdCsvDocument->getRowCont()->insert(aRow);
			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_EkiRessyabangou)
			{
				CdCsvRow	aRow;
				aRow.getCellCont()->insert(CdCsvCell(m_nameRessyabangou));
				aRow.getCellCont()->insert(CdCsvCell());
				pCdCsvDocument->getRowCont()->insert(aRow);
			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_EkiOperationNumber)
			{
				CdCsvRow	aRow;
				aRow.getCellCont()->insert(CdCsvCell(m_nameOperationNumber));
				aRow.getCellCont()->insert(CdCsvCell());
				pCdCsvDocument->getRowCont()->insert(aRow);
			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_EkiRessyasyubetsu)
			{
				CdCsvRow	aRow;
				aRow.getCellCont()->insert(CdCsvCell(m_nameRessyasyubetsu));
				aRow.getCellCont()->insert(CdCsvCell());
				pCdCsvDocument->getRowCont()->insert(aRow);
			}
			else if (aCdYColSpec.getColumnType() == CdYColSpec::ColumnType_EkiRessyamei)
			{
				CdCsvRow	aRow;
				aRow.getCellCont()->insert(CdCsvCell(m_nameRessyamei));
				aRow.getCellCont()->insert(CdCsvCell());
				pCdCsvDocument->getRowCont()->insert(aRow);

				CdCsvRow	aRow2;
				aRow.getCellCont()->insert(CdCsvCell(m_nameGousuu));
				aRow.getCellCont()->insert(CdCsvCell());
				pCdCsvDocument->getRowCont()->insert(aRow2);

				CdCsvRow	aRow3;
				aRow.getCellCont()->insert(CdCsvCell());
				aRow.getCellCont()->insert(CdCsvCell());
				pCdCsvDocument->getRowCont()->insert(aRow3);
			}
		}
	}

	//＜2.17＞<路線外終着駅>
	if (iRv >= 0 && bDisplayOuterTerminalShuchaku)
	{
		CdCsvRow	aRow;
		aRow.getCellCont()->insert(CdCsvCell(m_nameShuchakuEkimei));
		aRow.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->insert(aRow);
		CdCsvRow	aRow2;
		aRow2.getCellCont()->insert(CdCsvCell(m_nameJikoku));
		aRow2.getCellCont()->insert(CdCsvCell());
		pCdCsvDocument->getRowCont()->insert(aRow2);
	}
	//＜2.118＞[列1="備考" AND 列2=""]の列　備考列
	if ( iRv >= 0 )
	{
		CdCsvRow	aRow ;
		aRow.getCellCont()->insert( CdCsvCell( m_nameBikou ) ) ;
		aRow.getCellCont()->insert( CdCsvCell() ) ;
		pCdCsvDocument->getRowCont()->insert( aRow ) ;
	}
	// --------------------------------
	//	列車を出力(時刻表部分の3列目以降)
	// --------------------------------
	for (int idxRessya = iRessyaIndex;
		iRv >= 0 && idxRessya < iRessyaIndex + iRessyaCount;
		idxRessya++)
	{
		iRv = encode_AddRessya(
			pCentDedRessyasyubetsuContGet,
			pCentDedRessyaCont,
			contCustomizeRessyaIndex[idxRessya],
			pCdCsvDocument,
			pCentDedEkiCont,
			pCdDedEkiCont,
			bDisplayTsuukaEkiJikoku,
			bDisplaySecondEkiJikoku,
			bDisplayColonEkiJikoku, 
			bDisplayShihatsuShuchakuEkimei,
			bDisplayParentSyubetsu,
			bDisplayRessyamei,
			iEnableOperation,
			bDisplayOuterTerminalShihatsu,
			bDisplayOuterTerminalShuchaku);
	}
	
	return iRv ;
}
} //namespace ConvJikokuhyouCsv

